﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Bootik.FrmMan
{
    public partial class Product_Manage : Form
    {
        public Product_Manage()
        {
            InitializeComponent();
        }

        Product P;
        ProductHandller PH = new ProductHandller();
        int PCode = 0;
        Product PUpdate;
        string Barcode = "";
        CategoryHandller CH = new CategoryHandller();

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            txtBarcode.Text = "";
            txtcount.Text = "";
            txtDesc.Text = "";
            txtForush.Text = "";
            txtKharid.Text = "";
            txtnames.Text = "";
        }

        private void toolRegDaru_Click(object sender, EventArgs e)
        {
            try
            {
                P = new Product(txtnames.Text, txtKharid.Text, txtForush.Text, int.Parse(txtcount.Text),
                    Initializer.shelltime(), CH.GetId(cmbCat.Text), txtBarcode.Text, txtDesc.Text);
                if (txtnames.Text != "" && txtBarcode.Text != "")
                {
                    if (!PH.Exist(txtBarcode.Text))
                    {
                        if (PH.Insert(P))
                        {
                            MessageBox.Show("داده ها با موفقیت ثبت شدند", "موفقیت", MessageBoxButtons.OK, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign);
                            dataGridView1.DataSource = PH.ShowAll();
                        }
                        else
                            MessageBox.Show("عدم موفقیت در ثبت داده ها !!!! لطفا علت را بررسی کنید", "اخطار", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign);
                    }
                    else
                        MessageBox.Show("دارنده ی بارکد قبلا در بانک ذخیره شده است");
                }
                else
                {
                    MessageBox.Show("فیلد ها را کامل وارد کنید", "اخطار", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("خطای سیستم : " + ex.Message);
            }
        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            
        }

        private void Product_Manage_Load(object sender, EventArgs e)
        {
            try
            {
                cmbCat.DataSource = CH.ShowAll();
                cmbCat.DisplayMember = "Name";
                dataGridView1.DataSource = PH.ShowAll();
            }
            catch (Exception ex)
            {
                MessageBox.Show("خطای سیستم : " + ex.Message);
            }
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            try
            {
                PUpdate = new Product(txtnames.Text, txtKharid.Text, txtForush.Text, int.Parse(txtcount.Text),
                    Initializer.shelltime(), CH.GetId(cmbCat.Text), txtBarcode.Text, txtDesc.Text);
                //if (!PH.Exist(Barcode))
                    if (PH.Update(PUpdate, Barcode))
                        dataGridView1.DataSource = PH.ShowAll();
            }
            catch (Exception ex)
            {
                MessageBox.Show("خطای سیستم : " + ex.Message);
            }
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            try
            {
                if (MessageBox.Show("آیا مطمئن هستید ؟ ", "پیام", MessageBoxButtons.YesNo, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign) == DialogResult.Yes)
                {
                    if (PH.Delete(Barcode))
                        dataGridView1.DataSource = PH.ShowAll();
                    else
                        MessageBox.Show("عدم حذف داده مورد نظر.علت را بررسی کنید");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("خطای سیستم : " + ex.Message);
            }
        }

        private void cmbCat_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            try
            {
                PCode = int.Parse(dataGridView1.Rows[e.RowIndex].Cells[0].Value.ToString());
                txtnames.Text = dataGridView1.Rows[e.RowIndex].Cells[1].Value.ToString();
                txtKharid.Text = dataGridView1.Rows[e.RowIndex].Cells[2].Value.ToString();
                txtForush.Text = dataGridView1.Rows[e.RowIndex].Cells[3].Value.ToString();
                txtcount.Text = dataGridView1.Rows[e.RowIndex].Cells[4].Value.ToString();
                txtBarcode.Text = dataGridView1.Rows[e.RowIndex].Cells[7].Value.ToString();

                Barcode = dataGridView1.Rows[e.RowIndex].Cells[7].Value.ToString();

                txtDesc.Text = dataGridView1.Rows[e.RowIndex].Cells[8].Value.ToString();
            }
            catch (Exception ec)
            {
                MessageBox.Show(ec.Message);
            }
        }
    }
}
