﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
namespace Bootik
{
    public class ReportHandller
    {
         private DataBase DBcnn;
        private String StrSQL;

        public ReportHandller()
        {
            DBcnn = new DataBase();
            StrSQL = "";
        }

        public DataTable ShowZeroProducts()
        {
            string Sq = "select Name as 'نام',Count as 'تعداد',DateInsert as 'تاریخ ثبت' from product where Count=0";
            System.Data.DataTable dt = new System.Data.DataTable();
            try
            {
                dt = DBcnn.ExecuteSelectSQL(Sq);
            }
            catch (Exception ex)
            {
                dt = null;
            }
            return dt;
        }

        /// <summary>
        /// gozareshe liste sefareshat
        /// </summary>
        /// <param name="FromDateYear"></param>
        /// <param name="ToDateYear"></param>
        /// <param name="FromDateMonth"></param>
        /// <param name="ToDateMonth"></param>
        /// <param name="FromDateDay"></param>
        /// <param name="ToDateDay"></param>
        /// <returns></returns>
        public DataTable PrintAllOrder(int FromDateYear, int ToDateYear, int FromDateMonth, int ToDateMonth,int FromDateDay,int ToDateDay)
        {
            string Sq = "select OrderId as 'کد',Count as 'تعداد',SumForush as 'میزان فروش',SumSood as 'میزان سود',PayTtpe as 'نوع پرداخت' from Orders where DateYear between '" + FromDateYear + "' and '" + ToDateYear + "' and DateMonth between '" + FromDateMonth + "' and '" + ToDateMonth + "' and DateDay between '" + FromDateDay + "' and '" + ToDateDay + "'";
            System.Data.DataTable dt = new System.Data.DataTable();
            try
            {
                dt = DBcnn.ExecuteSelectSQL(Sq);
            }
            catch (Exception ex)
            {
                dt = null;
            }
            return dt;
        }

        public DataTable LoginLogoutCashier()
        {
            string Sq = "select LoginLogout.DateLogIn as 'تاریخ ورود',LoginLogout.DateLogOut as 'تاریخ خروج',Cashier.Name+' '+Cashier.Family as 'صندوق دار' from LoginLogout,Cashier where Cashier.Id=LoginLogout.SandughId";
            System.Data.DataTable dt = new System.Data.DataTable();
            try
            {
                dt = DBcnn.ExecuteSelectSQL(Sq);
            }
            catch (Exception ex)
            {
                dt = null;
            }
            return dt;
        }


        public DataTable LoginLogoutMan()
        {
            string Sq = "select distinct LoginLogout.DateLogIn as 'تاریخ ورود',LoginLogout.DateLogOut as 'تاریخ خروج',Manager.Name+' '+Manager.Family as 'مدیر' from LoginLogout,Manager where Manager.Id=LoginLogout.ManId ";
            System.Data.DataTable dt = new System.Data.DataTable();
            try
            {
                dt = DBcnn.ExecuteSelectSQL(Sq);
            }
            catch (Exception ex)
            {
                dt = null;
            }
            return dt;
        }
        




    }
}
