﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Bootik.FrmMan
{
    public partial class Cashier_Manage : Form
    {
        public Cashier_Manage()
        {
            InitializeComponent();
        }

        Cashier C;

        string melliCode = "";
        CashierHandller CH = new CashierHandller();

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            txtAddress.Text = "";
            txtFamily.Text = "";
            txtMellicode.Text = "";
            txtMob.Text = "";
            txtname.Text = "";
            txtPass.Text = "";
            txtTel.Text = "";
            txtUsername.Text = "";

        }

        private void toolRegDaru_Click(object sender, EventArgs e)
        {
            try
            {
                C = new Cashier(txtname.Text, txtFamily.Text, txtMob.Text, txtTel.Text, txtAddress.Text, Initializer.shelltime(), txtUsername.Text, txtPass.Text, txtMellicode.Text);
                if (txtname.Text != "" && txtFamily.Text != "" && txtMellicode.Text != "")
                {
                    if (!CH.Exist(txtMellicode.Text))
                    {
                        if (CH.Insert(C))
                        {
                            MessageBox.Show("داده ها با موفقیت ثبت شدند", "موفقیت", MessageBoxButtons.OK, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign);
                            dataGridView1.DataSource = CH.ShowAll();
                        }
                        else
                            MessageBox.Show("عدم موفقیت در ثبت داده ها !!!! لطفا علت را بررسی کنید", "اخطار", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign);
                    }
                    else
                        MessageBox.Show("دارنده ی این کد ملی قبلا در بانک ذخیره شده است");
                }
                else
                {
                    MessageBox.Show("فیلد ها را کامل وارد کنید", "اخطار", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("خطای سیستم : " + ex.Message);
            }
        }

        private void Cashier_Manage_Load(object sender, EventArgs e)
        {
            try
            {
                dataGridView1.DataSource = CH.ShowAll();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
           
        }

        private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            try
            {
                melliCode = dataGridView1.Rows[e.RowIndex].Cells[9].Value.ToString();
                txtname.Text = dataGridView1.Rows[e.RowIndex].Cells[1].Value.ToString();
                txtFamily.Text = dataGridView1.Rows[e.RowIndex].Cells[2].Value.ToString();
                txtMob.Text = dataGridView1.Rows[e.RowIndex].Cells[3].Value.ToString();
                txtTel.Text = dataGridView1.Rows[e.RowIndex].Cells[4].Value.ToString();
                txtAddress.Text = dataGridView1.Rows[e.RowIndex].Cells[5].Value.ToString();
                txtUsername.Text = dataGridView1.Rows[e.RowIndex].Cells[7].Value.ToString();
                txtPass.Text = dataGridView1.Rows[e.RowIndex].Cells[8].Value.ToString();
                txtMellicode.Text = dataGridView1.Rows[e.RowIndex].Cells[9].Value.ToString();
            }
            catch (Exception ec)
            {
                MessageBox.Show(ec.Message);
            }
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            try
            {
                if (MessageBox.Show("آیا مطمئن هستید ؟ ", "پیام", MessageBoxButtons.YesNo, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign) == DialogResult.Yes)
                {
                    if (CH.Delete(melliCode))
                        dataGridView1.DataSource = CH.ShowAll();
                    else
                        MessageBox.Show("عدم حذف داده مورد نظر.علت را بررسی کنید");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("خطای سیستم : " + ex.Message);
            }
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            try
            {
                if (CH.Update(txtname.Text, txtFamily.Text, txtMob.Text, txtTel.Text, txtAddress.Text, Initializer.shelltime(), txtUsername.Text, txtPass.Text, txtMellicode.Text))
                {
                    dataGridView1.DataSource = CH.ShowAll();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("خطای سیستم : " + ex.Message);
            }
        }
    }
}
